import java.awt.*;
import javax.swing.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 17.11.2010
  * @author Daniel Garmann
  */

public class Grafikliste {

  // Anfang Attribute
  private List liste;
  private Graphics g;
  // Ende Attribute

  public Grafikliste() {
    liste = new List();
  }

  public Grafikliste(Graphics g) {
    this.g = g;
    liste = new List();
  }


  // Anfang Methoden
  public void vor() {
    Object akt = liste.getObject();
    liste.next();
    if (!liste.hasAccess())
      liste.toLast();
  }

  public void zurueck() {
    Object akt = liste.getObject();
    liste.toFirst();
    if (akt != liste.getObject()) {
       Object prev = liste.getObject();
       liste.next();
       while (liste.getObject() != akt) {
         prev = liste.getObject();
         liste.next();
       }
       for (liste.toFirst(); liste.getObject()!=prev; liste.next()) ;
    }
  }

  public void anfang() {
    liste.toFirst();
  }

  public void ende() {
    liste.toLast();
  }

  public void zeichnealle() {
  
    if (!liste.isEmpty()) {
      Object akt = liste.getObject();

      for (liste.toFirst(); liste.hasAccess(); liste.next()) {
        zeichne();
      }

      for (liste.toFirst(); liste.getObject()!=akt; liste.next()) ;
      markiere();
    }
  }

  public void zeichne() {
    if (!liste.isEmpty())
      ((Grafikobjekt)liste.getObject()).zeichne(g);
  }

  public void markiere() {
    if (!liste.isEmpty())
      ((Grafikobjekt)liste.getObject()).markiere(g);
  }
  
  public void verschiebe(int dx, int dy) {
    if (!liste.isEmpty()) {
      ((Grafikobjekt)liste.getObject()).verschiebe(dx, dy);
    }
  }

  public void update() {
    g.clearRect(0,0,1000,1000);
    g.setColor(Color.black);
    g.drawRect(0,0,699,499);
    zeichnealle();
    markiere();
  }

  public void einfuegen(Grafikobjekt grafikobjekt) {
    liste.append(grafikobjekt);
    liste.toLast();
  }

  public void loeschen() {
    if (!liste.isEmpty()) {
      liste.remove();
      if (!liste.hasAccess())
        liste.toLast();
    }
  }

  public Graphics getZeichenflaeche() {
    return g;
  }

  public void setZeichenflaeche(Graphics g) {
    this.g = g;
  }

  public void nachvorne() {
    if (!liste.isEmpty()) {
      Object akt = liste.getObject();
      liste.remove();
      liste.next();
      if (liste.hasAccess()) {
        liste.insert(akt);
        for (liste.toFirst(); liste.getObject()!=akt; liste.next()) ;
      } else {
        liste.append(akt);
        liste.toLast();
      }
    }
  }
  
  public void nachhinten() {
    if (!liste.isEmpty()) {
      Object akt = liste.getObject();
      liste.remove();
      zurueck();
      liste.insert(akt);
      zurueck();
    }
  }
  
  public void nachoben() {
    if (!liste.isEmpty()) {
      verschiebe(0,-10);
    }
  }
  public void nachunten() {
    if (!liste.isEmpty()) {
      verschiebe(0,+10);
    }
  }
  public void nachlinks() {
    if (!liste.isEmpty()) {
      verschiebe(-10,0);
    }
  }
  public void nachrechts() {
    if (!liste.isEmpty()) {
      verschiebe(10,0);
    }
  }
  
  public void farbenaendern(Color linienfarbe, Color fuellfarbe) {
    if (!liste.isEmpty())
      ((Grafikobjekt)liste.getObject()).setLinienfarbe(linienfarbe);
      if ((Grafikobjekt)liste.getObject() instanceof Flaechenobjekt)
        ((Flaechenobjekt)liste.getObject()).setFuellfarbe(fuellfarbe);
  }

  // Ende Methoden
}
